//First-Fit Memory Allocation algorithm scans the memory and whenever it finds the first big enough hole to store a process, 
//it stops scanning and loads the process into that hole/block. 

function [ff_allot]=firstFit(p,b,size_process, size_block)
  

//Declaring first fit flag array( ff_flag) which is used for maintaining the status of each block(free or busy)

    ff_allot = zeros(1,size_process);       //    Declaring first fit array(ff_allot)
    ff_flag = zeros(1,size_block);
    
    // For loop for allocating blocks according to first fit
    
    for i=1:size_process
        for j=1:size_block
        if p(i) <= b(j) && ff_flag(j)==0 then       // if process size is less than block size and block is free
            ff_allot(i) = j;                        // store index position of the block in ff_allot in the index position i(process number)
            ff_flag(j) = 1;                         // set status as busy 
            break
            end,         
        end
    end
endfunction
